02/23/95 02:26:46 PM

frame
        "Answer the receiver's frame if any."

    #modifiedByOSI.
    self mainView isMDIFrame ifTrue: [ ^self mainView ].
    self mainView isMDIChild ifFalse:[^nil].
    ^self mainView frame!
destroy
    "Modified by OSI to check if menuWindow has a valid handle"
    "Private - destroy the receiver."
    #modifiedByOSI.
    self frame removeMdipane: self.
    self frame mdiDestroy: self.
    self frame avoidDestroyCurrentMenu: self.
    self menuWindow isHandleOk ifTrue: [ self menuWindow destroy ].
    MDIFrame mdiSelected: true.! 
topPaneClass
    "Modified by OSI to support opening any window
     as an MDI parent or child"
        "Private - Answer the default top pane class."
    #modifiedByOSI.
    Smalltalk isRunTime ifFalse: [
        (Smalltalk includesKey: #MDISystem) ifTrue: [
            (Smalltalk at: #MDISystem) isActive ifTrue:[^MDIChild]]].
    ^Smalltalk at: (Smalltalk at: #TopPaneClass ifAbsent: [ #TopPane ]).!   
mdiArrange
    "Added by OSI. Arrange the MDI documents."
    #addedByOSI.
    self frame mdiArrange!  
addMDIChildMenus
        "Private - add the menus to the menu bar."
    | textPane menu eachMenu hasSmalltalkMenuBar owner |
    ( window hasSmalltalkMenuBar and:
      [ window menuWindow menus isEmpty ] )
        ifTrue: [
            window menuWindow: window frame makeInitMdiMenu .
            window menuWindow menus isEmpty
                ifTrue:[ self addFileMenu ] ].

    window hasSmalltalkMenuBar ifTrue: [
        self addEditMenu.
        self addSmalltalkMenu.
        (Smalltalk includesKey: #WindowBuilder) ifTrue: [ self addWindowBuilderMenu ].
        self addApplicationMenus ].

    window event:#menuBuilt.     " OBSOLETE "
    window triggerEvent: #menuBarBuilt.

    window mdiMenuWindow: window frame makeMdiMenu.
    window mdiMenuWindow menus do: [ :m |
        window menuWindow addMenu: m ].
    window mdiMenuWindow menus do: [ :m |
        eachMenu := window frame  menuWindow menuTitled: m title.
        eachMenu notNil
            ifTrue: [ m copyAttributesFrom: eachMenu ] ].

    window menuWindow parent: window frame.
    window menuWindow owner: window.
    window menuWindow systemMenu owner: window.!   
wmMouseactivate: wParam with: lParam
        "Private - If mouse has been clicked on an inactive
         window, select it."
    self mainWindow mdiSelected: true.
    ^MaActivate
!   
initMdiWindowSize
    "Modified by OSI with thanks to Robert Gurrieri"
        "Private-Answer the default size of a document."
    |rect extent origin sizeRect offset |

    #modifiedByOSI.
    rect:=self frame mdiClient rectangle.

    "if framingBlock notNil, use it for initial rectangle."
    framingBlock notNil  ifTrue: [
        "If the corner is less than autoCascadeTolerance use an offset"
        sizeRect := framingBlock value: rect.
        sizeRect leftTop < self autoCascadeTolerance ifTrue: [
            offset := (UserLibrary getSystemMetrics: SmCysize) +
                (UserLibrary getSystemMetrics: SmCyframe).
            ^sizeRect moveTo: ((self frame mdiChildren size - 1) * (offset @ offset))
        ] ifFalse: [
            ^sizeRect
        ].
    ] ifFalse: [
        extent := (rect width * 24 // 25) @ (rect height * 24 // 25).
        extent := extent - ((self frame mdiChildren size - 1) * ( 8 @ 8)).
        origin :=(self frame mdiChildren size - 1) * (8 @ 8).
        ^origin extent: extent
    ].!  
autoCascadeTolerance
		#addedByOSI.
    ^1@1!   
mdiTile
    "Added by OSI. Tile the MDI documents."
    #addedByOSI.
    self frame mdiTile!   
mdiCloseAll
    "Added by OSI. Close all MDI documents
     which are not minimized."
    #addedByOSI.
    self frame mdiCloseAll!
mdiCascade
    "Added by OSI. Cascade the MDI documents."
    #addedByOSI.
    self frame mdiCascade!